Attribute VB_Name = "mAnimation"
Option Explicit

'Types
    Type tAnimation
        'System
        NextTick As Long
        PhaseCount As tCoord2D
        
        'Public
        Enabled As Boolean
        ActPhase As tCoord2D
        
        Speed As Long
    End Type

'API
    Public Declare Function GetTickCount Lib "kernel32" () As Long

Public Sub Animate(iAnimation As tAnimation)
    Dim Temp As Long
    
    Temp = GetTickCount
    
    'If enabled
    If iAnimation.Enabled = True Then
    
        'And if next tick was reached
        If iAnimation.NextTick <= Temp Then
            iAnimation.NextTick = Temp + iAnimation.Speed
            
            'Animate
            iAnimation.ActPhase.x = iAnimation.ActPhase.x + 1
            
            'Check if maximum is reached
            If iAnimation.ActPhase.x > iAnimation.PhaseCount.x Then
                'Step to next line
                iAnimation.ActPhase.x = 0
                iAnimation.ActPhase.y = iAnimation.ActPhase.y + 1
                
                'Check if maximum is reached
                If iAnimation.ActPhase.y > iAnimation.PhaseCount.y Then
                    iAnimation.ActPhase.y = 0
                End If
            End If
        End If
    End If
End Sub
