Attribute VB_Name = "mInput"
Option Explicit

'Types
    Type tMouse
        Position As tCoord2DFloat
    End Type

'Vars
    Global KD(255) As Boolean
    Global Mouse As tMouse
Public Sub CheckInput()
    Dim A As Long
    
    'Escape
    If KD(vbKeyEscape) = True Then: Active = False
    
    With Ship(0)
        'Left
        If KD(vbKeyLeft) = True Then
            If .Speed.X > -.MaxSpeed.X Then
                .Speed.X = .Speed.X - .Acceleration.X
            End If
            
        Else
            If KD(vbKeyRight) = False Then
                If .Speed.X < 0 Then: .Speed.X = .Speed.X + 0.05
            End If
        End If
        
        'Right
        If KD(vbKeyRight) = True Then
            If .Speed.X < .MaxSpeed.X Then
                .Speed.X = .Speed.X + .Acceleration.X
            End If
            
        Else
            If KD(vbKeyLeft) = False Then
                If .Speed.X > 0 Then: .Speed.X = .Speed.X - 0.05
            End If
        End If
        
        'Up
        If KD(vbKeyUp) = True Then
            If .Speed.Y > -.MaxSpeed.Y Then
                .Speed.Y = .Speed.Y - .Acceleration.Y
            End If
            
        Else
            If KD(vbKeyDown) = False Then
                If .Speed.Y < 0 Then: .Speed.Y = .Speed.Y + 0.05
            End If
        End If
        
        'Down
        If KD(vbKeyDown) = True Then
            If .Speed.Y < .MaxSpeed.Y Then
                .Speed.Y = .Speed.Y + .Acceleration.Y
            End If
            
        Else
            If KD(vbKeyUp) = False Then
                If .Speed.Y > 0 Then: .Speed.Y = .Speed.Y - 0.05
            End If
        End If
        
        'Position
        If .Position.X < -(.Size.X / 2) Then: .Position.X = -(.Size.X / 2)
        If .Position.X > (Level.Size.X * TileW) - (.Size.X / 2) Then: .Position.X = (Level.Size.X * TileW) - (.Size.X / 2)
        If .Position.Y < 0 Then: .Position.Y = 0
        If .Position.Y > Camera.h - TileH Then: .Position.Y = Camera.h - TileH
        
        'Movement
        If Abs(.Speed.X) < 0.1 Then: .Speed.X = 0
        If Abs(.Speed.Y) < 0.1 Then: .Speed.Y = 0
        
        'Camera
        If .Position.X - Camera.X < 100 Then
            Camera.X = Camera.X - Abs(.Speed.X)
            If Camera.X < 0 Then: Camera.X = 0
        End If
    
        If .Position.X - Camera.X > Camera.w - 100 Then
            Camera.X = Camera.X + Abs(.Speed.X)
            If Camera.X + Camera.w > (Level.Size.X * TileW) Then: Camera.X = (Level.Size.X * TileW) - Camera.w
        End If
        
        'Space
        If KD(vbKeySpace) = True Then
            For A = 0 To .WeaponCount
                FireWeapon .Weapon(A)
            Next
        End If
    End With
End Sub
