Attribute VB_Name = "mTile"
Option Explicit

'Types
    Type tTile
        Bitmap As Long
        
        'Position in bitmap
        Position As tCoord2D
    End Type

'Vars
    Global TileW As Long
    Global TileH As Long

    Global TileCount As Long
    Global Tile() As tTile
Function ResetTiles() As Long
    'Tile size
    TileW = 24
    TileH = 24

    'Release memory
    TileCount = -1
    ReDim Tile(0)
End Function

Public Sub SaveTiles(iFilename As String)
    Dim A As Long
    Dim FileNumber As Integer
    
    FileNumber = FreeFile
    
    Open Path & iFilename For Binary As FileNumber
        Put FileNumber, , TileW
        Put FileNumber, , TileH
        Put FileNumber, , TileCount
        
        For A = 0 To TileCount
            With Tile(A)
                Put FileNumber, , Len(Bitmap(.Bitmap).FileName)
                Put FileNumber, , Bitmap(.Bitmap).FileName
                
'                Put FileNumber, , Bitmap(.Bitmap).Size
                Put FileNumber, , Bitmap(.Bitmap).Animation
                
                Put FileNumber, , .Position
            End With
        Next
    Close FileNumber
End Sub


Public Sub LoadTiles(iFilename As String)
    Dim A As Long
    Dim Temp As Long
    Dim Temp2 As String
    Dim FileNumber As Integer
    
    FileNumber = FreeFile
    
    Open Path & iFilename For Binary As FileNumber
        Get FileNumber, , TileW
        Get FileNumber, , TileH
        Get FileNumber, , TileCount
        ReDim Tile(TileCount)
        For A = 0 To TileCount
            With Tile(A)
                Get FileNumber, , Temp
                Temp2 = Space(Temp)
                Get FileNumber, , Temp2
                .Bitmap = LoadBitmap(Temp2)
                
'                Get FileNumber, , Bitmap(.Bitmap).Size
                Get FileNumber, , Bitmap(.Bitmap).Animation
                
                Get FileNumber, , .Position
            End With
        Next
    Close FileNumber
End Sub
