Attribute VB_Name = "mWeapon"
Option Explicit

'Type
    Type tWeapon
        Interval As Long
        Wait As Long
        
        Sound As String
        SoundChannel As Long
  
        ShotPosition As tCoord2D
        
        Ship As Long
        Shot As Long
    End Type

'Vars
    Global SrcWeaponCount As Long
    Global SrcWeapon() As tWeapon
Public Sub FireWeapon(iWeapon As tWeapon)
    Dim Temp As Long
    
    Temp = GetTickCount
    
    With iWeapon
        If .Wait < Temp Then
            .Wait = Temp + .Interval
            
            AddShot iWeapon
            If Not iWeapon.Sound = "" Then: PlaySound Path & iWeapon.Sound, False
        End If
    End With
End Sub


Public Sub ResetWeapons()
    SrcWeaponCount = -1
    ReDim SrcWeapon(0)
End Sub


Public Sub SaveWeapons(iFilename As String)
    Dim A As Long
    Dim FileNumber As Integer

    FileNumber = FreeFile
    
    Open Path & iFilename For Binary As FileNumber
        Put FileNumber, , SrcWeaponCount
        For A = 0 To SrcWeaponCount
            Put FileNumber, , SrcWeapon(A)
        Next
    Close FileNumber
End Sub


Public Sub LoadWeapons(iFilename As String)
    Dim A As Long
    Dim FileNumber As Integer

    FileNumber = FreeFile
    
    Open Path & iFilename For Binary As FileNumber
        Get FileNumber, , SrcWeaponCount
        ReDim SrcWeapon(SrcWeaponCount)
        
        For A = 0 To SrcWeaponCount
            Get FileNumber, , SrcWeapon(A)
        Next
    Close FileNumber
End Sub
